/* Plug.c generated by valac 0.56.17, the Vala compiler
 * generated from Plug.vala, do not modify */

/*
 * Copyright (c) 2011-2017 elementary LLC. (https://elementary.io)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA
 */

#include "sharing.h"
#include <gtk/gtk.h>
#include <switchboard.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <gee.h>
#include <glib-object.h>
#include <glib/gi18n-lib.h>
#include <granite.h>
#include <gmodule.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	SHARING_PLUG_0_PROPERTY,
	SHARING_PLUG_NUM_PROPERTIES
};
static GParamSpec* sharing_plug_properties[SHARING_PLUG_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _SharingPlugSearchData SharingPlugSearchData;

struct _SharingPlugPrivate {
	GtkStack* content;
};

struct _SharingPlugSearchData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	SharingPlug* self;
	gchar* search;
	GeeTreeMap* result;
	GeeTreeMap* search_results;
	GCompareFunc _tmp0_;
	GEqualFunc _tmp1_;
	GeeTreeMap* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
};

static gint SharingPlug_private_offset;
static gpointer sharing_plug_parent_class = NULL;

static GtkWidget* sharing_plug_real_get_widget (SwitchboardPlug* base);
static void ___lambda9_ (SharingPlug* self);
static void sharing_plug_update_content_view (SharingPlug* self);
static void ____lambda9__g_network_monitor_network_changed (GNetworkMonitor* _sender,
                                                     gboolean network_available,
                                                     gpointer self);
static void _sharing_widgets_settings_view_show_service_settings_sharing_widgets_sidebar_selected_service_changed (SharingWidgetsSidebar* _sender,
                                                                                                            const gchar* service_id,
                                                                                                            gpointer self);
static void sharing_plug_real_shown (SwitchboardPlug* base);
static void sharing_plug_real_hidden (SwitchboardPlug* base);
static void sharing_plug_real_search_callback (SwitchboardPlug* base,
                                        const gchar* location);
static void sharing_plug_real_search_data_free (gpointer _data);
static void sharing_plug_real_search (SwitchboardPlug* base,
                               const gchar* search,
                               GAsyncReadyCallback _callback_,
                               gpointer _user_data_);
static gboolean sharing_plug_real_search_co (SharingPlugSearchData* _data_);
static void sharing_plug_finalize (GObject * obj);
static GType sharing_plug_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
sharing_plug_get_instance_private (SharingPlug* self)
{
	return G_STRUCT_MEMBER_P (self, SharingPlug_private_offset);
}

SharingPlug*
sharing_plug_construct (GType object_type)
{
	SharingPlug * self = NULL;
	GeeTreeMap* settings = NULL;
	GeeTreeMap* _tmp0_;
#line 24 "../src/Plug.vala"
	bindtextdomain (GETTEXT_PACKAGE, LOCALEDIR);
#line 25 "../src/Plug.vala"
	bind_textdomain_codeset (GETTEXT_PACKAGE, "UTF-8");
#line 27 "../src/Plug.vala"
	_tmp0_ = gee_tree_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL);
#line 27 "../src/Plug.vala"
	settings = _tmp0_;
#line 28 "../src/Plug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) settings, "network/share", NULL);
#line 29 "../src/Plug.vala"
	self = (SharingPlug*) g_object_new (object_type, "category", SWITCHBOARD_PLUG_CATEGORY_NETWORK, "code-name", "io.elementary.switchboard.sharing", "display-name", _ ("Sharing"), "description", _ ("Configure file and media sharing"), "icon", "preferences-system-sharing", "supported-settings", settings, NULL);
#line 23 "../src/Plug.vala"
	_g_object_unref0 (settings);
#line 23 "../src/Plug.vala"
	return self;
#line 136 "Plug.c"
}

SharingPlug*
sharing_plug_new (void)
{
#line 23 "../src/Plug.vala"
	return sharing_plug_construct (SHARING_TYPE_PLUG);
#line 144 "Plug.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 59 "../src/Plug.vala"
	return self ? g_object_ref (self) : NULL;
#line 152 "Plug.c"
}

static void
___lambda9_ (SharingPlug* self)
{
#line 72 "../src/Plug.vala"
	sharing_plug_update_content_view (self);
#line 160 "Plug.c"
}

static void
____lambda9__g_network_monitor_network_changed (GNetworkMonitor* _sender,
                                                gboolean network_available,
                                                gpointer self)
{
#line 72 "../src/Plug.vala"
	___lambda9_ ((SharingPlug*) self);
#line 170 "Plug.c"
}

static void
_sharing_widgets_settings_view_show_service_settings_sharing_widgets_sidebar_selected_service_changed (SharingWidgetsSidebar* _sender,
                                                                                                       const gchar* service_id,
                                                                                                       gpointer self)
{
#line 73 "../src/Plug.vala"
	sharing_widgets_settings_view_show_service_settings ((SharingWidgetsSettingsView*) self, service_id);
#line 180 "Plug.c"
}

static GtkWidget*
sharing_plug_real_get_widget (SwitchboardPlug* base)
{
	SharingPlug * self;
	GtkStack* _tmp0_;
	GtkStack* _tmp38_;
	GtkWidget* _tmp39_;
	GtkWidget* result;
#line 37 "../src/Plug.vala"
	self = (SharingPlug*) base;
#line 38 "../src/Plug.vala"
	_tmp0_ = self->priv->content;
#line 38 "../src/Plug.vala"
	if (_tmp0_ == NULL) {
#line 197 "Plug.c"
		GraniteWidgetsAlertView* network_alert_view = NULL;
		GraniteWidgetsAlertView* _tmp1_;
		GraniteWidgetsAlertView* _tmp2_;
		GtkStyleContext* _tmp3_;
		GtkLinkButton* link_button = NULL;
		GtkLinkButton* _tmp4_;
		GtkLinkButton* _tmp5_;
		GtkLinkButton* _tmp6_;
		GtkLinkButton* _tmp7_;
		GtkGrid* network_grid_view = NULL;
		GtkGrid* _tmp8_;
		GtkGrid* _tmp9_;
		GtkGrid* _tmp10_;
		GraniteWidgetsAlertView* _tmp11_;
		GtkGrid* _tmp12_;
		GtkLinkButton* _tmp13_;
		SharingWidgetsSidebar* sidebar = NULL;
		SharingWidgetsSidebar* _tmp14_;
		SharingWidgetsSettingsView* settings_view = NULL;
		SharingWidgetsSettingsView* _tmp15_;
		SharingWidgetsSettingsView* _tmp16_;
		gint _tmp17_ = 0;
		SharingWidgetsSettingsPage** _tmp18_;
		GtkPaned* main_container = NULL;
		GtkPaned* _tmp24_;
		GtkPaned* _tmp25_;
		SharingWidgetsSidebar* _tmp26_;
		GtkPaned* _tmp27_;
		SharingWidgetsSettingsView* _tmp28_;
		GtkStack* _tmp29_;
		GtkStack* _tmp30_;
		GtkPaned* _tmp31_;
		GtkStack* _tmp32_;
		GtkGrid* _tmp33_;
		GtkStack* _tmp34_;
		GNetworkMonitor* _tmp35_;
		SharingWidgetsSidebar* _tmp36_;
		SharingWidgetsSettingsView* _tmp37_;
#line 39 "../src/Plug.vala"
		_tmp1_ = granite_widgets_alert_view_new (_ ("Network Is Not Available"), _ ("While disconnected from the network, sharing services are not availabl" \
"e."), "network-error");
#line 39 "../src/Plug.vala"
		g_object_ref_sink (_tmp1_);
#line 39 "../src/Plug.vala"
		network_alert_view = _tmp1_;
#line 44 "../src/Plug.vala"
		_tmp2_ = network_alert_view;
#line 44 "../src/Plug.vala"
		_tmp3_ = gtk_widget_get_style_context ((GtkWidget*) _tmp2_);
#line 44 "../src/Plug.vala"
		gtk_style_context_remove_class (_tmp3_, GTK_STYLE_CLASS_VIEW);
#line 46 "../src/Plug.vala"
		_tmp4_ = (GtkLinkButton*) gtk_link_button_new_with_label ("settings://network", _ ("Network settings…"));
#line 46 "../src/Plug.vala"
		g_object_ref_sink (_tmp4_);
#line 46 "../src/Plug.vala"
		link_button = _tmp4_;
#line 47 "../src/Plug.vala"
		_tmp5_ = link_button;
#line 47 "../src/Plug.vala"
		gtk_widget_set_halign ((GtkWidget*) _tmp5_, GTK_ALIGN_END);
#line 48 "../src/Plug.vala"
		_tmp6_ = link_button;
#line 48 "../src/Plug.vala"
		gtk_widget_set_valign ((GtkWidget*) _tmp6_, GTK_ALIGN_END);
#line 49 "../src/Plug.vala"
		_tmp7_ = link_button;
#line 49 "../src/Plug.vala"
		gtk_widget_set_vexpand ((GtkWidget*) _tmp7_, TRUE);
#line 51 "../src/Plug.vala"
		_tmp8_ = (GtkGrid*) gtk_grid_new ();
#line 51 "../src/Plug.vala"
		g_object_ref_sink (_tmp8_);
#line 51 "../src/Plug.vala"
		network_grid_view = _tmp8_;
#line 52 "../src/Plug.vala"
		_tmp9_ = network_grid_view;
#line 52 "../src/Plug.vala"
		g_object_set ((GtkWidget*) _tmp9_, "margin", 24, NULL);
#line 53 "../src/Plug.vala"
		_tmp10_ = network_grid_view;
#line 53 "../src/Plug.vala"
		_tmp11_ = network_alert_view;
#line 53 "../src/Plug.vala"
		gtk_grid_attach (_tmp10_, (GtkWidget*) _tmp11_, 0, 0, 1, 1);
#line 54 "../src/Plug.vala"
		_tmp12_ = network_grid_view;
#line 54 "../src/Plug.vala"
		_tmp13_ = link_button;
#line 54 "../src/Plug.vala"
		gtk_grid_attach (_tmp12_, (GtkWidget*) _tmp13_, 0, 1, 1, 1);
#line 56 "../src/Plug.vala"
		_tmp14_ = sharing_widgets_sidebar_new ();
#line 56 "../src/Plug.vala"
		g_object_ref_sink (_tmp14_);
#line 56 "../src/Plug.vala"
		sidebar = _tmp14_;
#line 57 "../src/Plug.vala"
		_tmp15_ = sharing_widgets_settings_view_new ();
#line 57 "../src/Plug.vala"
		g_object_ref_sink (_tmp15_);
#line 57 "../src/Plug.vala"
		settings_view = _tmp15_;
#line 59 "../src/Plug.vala"
		_tmp16_ = settings_view;
#line 59 "../src/Plug.vala"
		_tmp18_ = sharing_widgets_settings_view_get_settings_pages (_tmp16_, &_tmp17_);
#line 304 "Plug.c"
		{
			SharingWidgetsSettingsPage** settings_page_collection = NULL;
			gint settings_page_collection_length1 = 0;
			gint _settings_page_collection_size_ = 0;
			gint settings_page_it = 0;
#line 59 "../src/Plug.vala"
			settings_page_collection = _tmp18_;
#line 59 "../src/Plug.vala"
			settings_page_collection_length1 = _tmp17_;
#line 59 "../src/Plug.vala"
			for (settings_page_it = 0; settings_page_it < settings_page_collection_length1; settings_page_it = settings_page_it + 1) {
#line 316 "Plug.c"
				SharingWidgetsSettingsPage* _tmp19_;
				SharingWidgetsSettingsPage* settings_page = NULL;
#line 59 "../src/Plug.vala"
				_tmp19_ = _g_object_ref0 (settings_page_collection[settings_page_it]);
#line 59 "../src/Plug.vala"
				settings_page = _tmp19_;
#line 323 "Plug.c"
				{
					SharingWidgetsSidebar* _tmp20_;
					SharingWidgetsSettingsPage* _tmp21_;
					SharingWidgetsServiceEntry* _tmp22_;
					SharingWidgetsServiceEntry* _tmp23_;
#line 60 "../src/Plug.vala"
					_tmp20_ = sidebar;
#line 60 "../src/Plug.vala"
					_tmp21_ = settings_page;
#line 60 "../src/Plug.vala"
					_tmp22_ = sharing_widgets_settings_page_get_service_entry (_tmp21_);
#line 60 "../src/Plug.vala"
					_tmp23_ = _tmp22_;
#line 60 "../src/Plug.vala"
					sharing_widgets_sidebar_add_service_entry (_tmp20_, _tmp23_);
#line 60 "../src/Plug.vala"
					_g_object_unref0 (_tmp23_);
#line 59 "../src/Plug.vala"
					_g_object_unref0 (settings_page);
#line 343 "Plug.c"
				}
			}
#line 59 "../src/Plug.vala"
			settings_page_collection = (_vala_array_free (settings_page_collection, settings_page_collection_length1, (GDestroyNotify) g_object_unref), NULL);
#line 348 "Plug.c"
		}
#line 63 "../src/Plug.vala"
		_tmp24_ = (GtkPaned*) gtk_paned_new (GTK_ORIENTATION_HORIZONTAL);
#line 63 "../src/Plug.vala"
		g_object_ref_sink (_tmp24_);
#line 63 "../src/Plug.vala"
		main_container = _tmp24_;
#line 64 "../src/Plug.vala"
		_tmp25_ = main_container;
#line 64 "../src/Plug.vala"
		_tmp26_ = sidebar;
#line 64 "../src/Plug.vala"
		gtk_paned_pack1 (_tmp25_, (GtkWidget*) _tmp26_, FALSE, FALSE);
#line 65 "../src/Plug.vala"
		_tmp27_ = main_container;
#line 65 "../src/Plug.vala"
		_tmp28_ = settings_view;
#line 65 "../src/Plug.vala"
		gtk_paned_pack2 (_tmp27_, (GtkWidget*) _tmp28_, TRUE, FALSE);
#line 67 "../src/Plug.vala"
		_tmp29_ = (GtkStack*) gtk_stack_new ();
#line 67 "../src/Plug.vala"
		g_object_ref_sink (_tmp29_);
#line 67 "../src/Plug.vala"
		_g_object_unref0 (self->priv->content);
#line 67 "../src/Plug.vala"
		self->priv->content = _tmp29_;
#line 68 "../src/Plug.vala"
		_tmp30_ = self->priv->content;
#line 68 "../src/Plug.vala"
		_tmp31_ = main_container;
#line 68 "../src/Plug.vala"
		gtk_stack_add_named (_tmp30_, (GtkWidget*) _tmp31_, "main-container");
#line 69 "../src/Plug.vala"
		_tmp32_ = self->priv->content;
#line 69 "../src/Plug.vala"
		_tmp33_ = network_grid_view;
#line 69 "../src/Plug.vala"
		gtk_stack_add_named (_tmp32_, (GtkWidget*) _tmp33_, "network-alert-view");
#line 70 "../src/Plug.vala"
		_tmp34_ = self->priv->content;
#line 70 "../src/Plug.vala"
		gtk_widget_show_all ((GtkWidget*) _tmp34_);
#line 72 "../src/Plug.vala"
		_tmp35_ = g_network_monitor_get_default ();
#line 72 "../src/Plug.vala"
		g_signal_connect_object (_tmp35_, "network-changed", (GCallback) ____lambda9__g_network_monitor_network_changed, self, 0);
#line 73 "../src/Plug.vala"
		_tmp36_ = sidebar;
#line 73 "../src/Plug.vala"
		_tmp37_ = settings_view;
#line 73 "../src/Plug.vala"
		g_signal_connect_object (_tmp36_, "selected-service-changed", (GCallback) _sharing_widgets_settings_view_show_service_settings_sharing_widgets_sidebar_selected_service_changed, _tmp37_, 0);
#line 75 "../src/Plug.vala"
		sharing_plug_update_content_view (self);
#line 38 "../src/Plug.vala"
		_g_object_unref0 (main_container);
#line 38 "../src/Plug.vala"
		_g_object_unref0 (settings_view);
#line 38 "../src/Plug.vala"
		_g_object_unref0 (sidebar);
#line 38 "../src/Plug.vala"
		_g_object_unref0 (network_grid_view);
#line 38 "../src/Plug.vala"
		_g_object_unref0 (link_button);
#line 38 "../src/Plug.vala"
		_g_object_unref0 (network_alert_view);
#line 416 "Plug.c"
	}
#line 78 "../src/Plug.vala"
	_tmp38_ = self->priv->content;
#line 78 "../src/Plug.vala"
	_tmp39_ = _g_object_ref0 ((GtkWidget*) _tmp38_);
#line 78 "../src/Plug.vala"
	result = _tmp39_;
#line 78 "../src/Plug.vala"
	return result;
#line 426 "Plug.c"
}

static void
sharing_plug_real_shown (SwitchboardPlug* base)
{
	SharingPlug * self;
#line 81 "../src/Plug.vala"
	self = (SharingPlug*) base;
#line 435 "Plug.c"
}

static void
sharing_plug_real_hidden (SwitchboardPlug* base)
{
	SharingPlug * self;
#line 84 "../src/Plug.vala"
	self = (SharingPlug*) base;
#line 444 "Plug.c"
}

static void
sharing_plug_real_search_callback (SwitchboardPlug* base,
                                   const gchar* location)
{
	SharingPlug * self;
#line 87 "../src/Plug.vala"
	self = (SharingPlug*) base;
#line 87 "../src/Plug.vala"
	g_return_if_fail (location != NULL);
#line 456 "Plug.c"
}

static void
sharing_plug_real_search_data_free (gpointer _data)
{
	SharingPlugSearchData* _data_;
	_data_ = _data;
#line 20 "../src/Plug.vala"
	_g_free0 (_data_->search);
#line 20 "../src/Plug.vala"
	_g_object_unref0 (_data_->result);
#line 20 "../src/Plug.vala"
	_g_object_unref0 (_data_->self);
#line 20 "../src/Plug.vala"
	g_slice_free (SharingPlugSearchData, _data_);
#line 472 "Plug.c"
}

static void
sharing_plug_real_search (SwitchboardPlug* base,
                          const gchar* search,
                          GAsyncReadyCallback _callback_,
                          gpointer _user_data_)
{
	SharingPlug * self;
	SharingPlugSearchData* _data_;
	SharingPlug* _tmp0_;
	gchar* _tmp1_;
#line 20 "../src/Plug.vala"
	g_return_if_fail (search != NULL);
#line 20 "../src/Plug.vala"
	self = (SharingPlug*) base;
#line 20 "../src/Plug.vala"
	_data_ = g_slice_new0 (SharingPlugSearchData);
#line 20 "../src/Plug.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 20 "../src/Plug.vala"
	g_task_set_task_data (_data_->_async_result, _data_, sharing_plug_real_search_data_free);
#line 20 "../src/Plug.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 20 "../src/Plug.vala"
	_data_->self = _tmp0_;
#line 20 "../src/Plug.vala"
	_tmp1_ = g_strdup (search);
#line 20 "../src/Plug.vala"
	_g_free0 (_data_->search);
#line 20 "../src/Plug.vala"
	_data_->search = _tmp1_;
#line 20 "../src/Plug.vala"
	sharing_plug_real_search_co (_data_);
#line 507 "Plug.c"
}

static GeeTreeMap*
sharing_plug_search_finish (SwitchboardPlug* base,
                            GAsyncResult* _res_)
{
	GeeTreeMap* result;
	SharingPlugSearchData* _data_;
#line 20 "../src/Plug.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 20 "../src/Plug.vala"
	result = _data_->result;
#line 20 "../src/Plug.vala"
	_data_->result = NULL;
#line 20 "../src/Plug.vala"
	return result;
#line 524 "Plug.c"
}

static gboolean
sharing_plug_real_search_co (SharingPlugSearchData* _data_)
{
#line 91 "../src/Plug.vala"
	switch (_data_->_state_) {
#line 91 "../src/Plug.vala"
		case 0:
#line 534 "Plug.c"
		goto _state_0;
		default:
#line 91 "../src/Plug.vala"
		g_assert_not_reached ();
#line 539 "Plug.c"
	}
	_state_0:
#line 92 "../src/Plug.vala"
	_data_->_tmp0_ = ((GCompareFunc) g_strcmp0);
#line 92 "../src/Plug.vala"
	_data_->_tmp1_ = g_str_equal;
#line 92 "../src/Plug.vala"
	_data_->_tmp2_ = gee_tree_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, (GCompareDataFunc) _data_->_tmp0_, NULL, NULL, (GeeEqualDataFunc) _data_->_tmp1_, NULL, NULL);
#line 92 "../src/Plug.vala"
	_data_->search_results = _data_->_tmp2_;
#line 93 "../src/Plug.vala"
	_data_->_tmp3_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
#line 93 "../src/Plug.vala"
	_data_->_tmp4_ = _data_->_tmp3_;
#line 93 "../src/Plug.vala"
	_data_->_tmp5_ = g_strdup_printf ("%s → %s", _data_->_tmp4_, _ ("Media library"));
#line 93 "../src/Plug.vala"
	_data_->_tmp6_ = _data_->_tmp5_;
#line 93 "../src/Plug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _data_->search_results, _data_->_tmp6_, "");
#line 93 "../src/Plug.vala"
	_g_free0 (_data_->_tmp6_);
#line 94 "../src/Plug.vala"
	_data_->result = _data_->search_results;
#line 94 "../src/Plug.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 94 "../src/Plug.vala"
	if (_data_->_state_ != 0) {
#line 94 "../src/Plug.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 94 "../src/Plug.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 572 "Plug.c"
		}
	}
#line 94 "../src/Plug.vala"
	g_object_unref (_data_->_async_result);
#line 94 "../src/Plug.vala"
	return FALSE;
#line 579 "Plug.c"
}

static void
sharing_plug_update_content_view (SharingPlug* self)
{
	gboolean _tmp0_ = FALSE;
	GNetworkMonitor* _tmp1_;
#line 97 "../src/Plug.vala"
	g_return_if_fail (self != NULL);
#line 98 "../src/Plug.vala"
	_tmp1_ = g_network_monitor_get_default ();
#line 98 "../src/Plug.vala"
	if (g_network_monitor_get_network_available (_tmp1_)) {
#line 98 "../src/Plug.vala"
		_tmp0_ = TRUE;
#line 595 "Plug.c"
	} else {
		GNetworkMonitor* _tmp2_;
#line 98 "../src/Plug.vala"
		_tmp2_ = g_network_monitor_get_default ();
#line 98 "../src/Plug.vala"
		_tmp0_ = g_network_monitor_get_network_metered (_tmp2_);
#line 602 "Plug.c"
	}
#line 98 "../src/Plug.vala"
	if (_tmp0_) {
#line 606 "Plug.c"
		GtkStack* _tmp3_;
#line 99 "../src/Plug.vala"
		_tmp3_ = self->priv->content;
#line 99 "../src/Plug.vala"
		gtk_stack_set_visible_child_name (_tmp3_, "main-container");
#line 612 "Plug.c"
	} else {
		GtkStack* _tmp4_;
#line 101 "../src/Plug.vala"
		_tmp4_ = self->priv->content;
#line 101 "../src/Plug.vala"
		gtk_stack_set_visible_child_name (_tmp4_, "network-alert-view");
#line 619 "Plug.c"
	}
}

static void
sharing_plug_class_init (SharingPlugClass * klass,
                         gpointer klass_data)
{
#line 20 "../src/Plug.vala"
	sharing_plug_parent_class = g_type_class_peek_parent (klass);
#line 20 "../src/Plug.vala"
	g_type_class_adjust_private_offset (klass, &SharingPlug_private_offset);
#line 20 "../src/Plug.vala"
	((SwitchboardPlugClass *) klass)->get_widget = (GtkWidget* (*) (SwitchboardPlug*)) sharing_plug_real_get_widget;
#line 20 "../src/Plug.vala"
	((SwitchboardPlugClass *) klass)->shown = (void (*) (SwitchboardPlug*)) sharing_plug_real_shown;
#line 20 "../src/Plug.vala"
	((SwitchboardPlugClass *) klass)->hidden = (void (*) (SwitchboardPlug*)) sharing_plug_real_hidden;
#line 20 "../src/Plug.vala"
	((SwitchboardPlugClass *) klass)->search_callback = (void (*) (SwitchboardPlug*, const gchar*)) sharing_plug_real_search_callback;
#line 20 "../src/Plug.vala"
	((SwitchboardPlugClass *) klass)->search = (void (*) (SwitchboardPlug*, const gchar*, GAsyncReadyCallback, gpointer)) sharing_plug_real_search;
#line 20 "../src/Plug.vala"
	((SwitchboardPlugClass *) klass)->search_finish = (GeeTreeMap* (*) (SwitchboardPlug*, GAsyncResult*)) sharing_plug_search_finish;
#line 20 "../src/Plug.vala"
	G_OBJECT_CLASS (klass)->finalize = sharing_plug_finalize;
#line 645 "Plug.c"
}

static void
sharing_plug_instance_init (SharingPlug * self,
                            gpointer klass)
{
#line 20 "../src/Plug.vala"
	self->priv = sharing_plug_get_instance_private (self);
#line 21 "../src/Plug.vala"
	self->priv->content = NULL;
#line 656 "Plug.c"
}

static void
sharing_plug_finalize (GObject * obj)
{
	SharingPlug * self;
#line 20 "../src/Plug.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SHARING_TYPE_PLUG, SharingPlug);
#line 21 "../src/Plug.vala"
	_g_object_unref0 (self->priv->content);
#line 20 "../src/Plug.vala"
	G_OBJECT_CLASS (sharing_plug_parent_class)->finalize (obj);
#line 669 "Plug.c"
}

static GType
sharing_plug_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SharingPlugClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sharing_plug_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SharingPlug), 0, (GInstanceInitFunc) sharing_plug_instance_init, NULL };
	GType sharing_plug_type_id;
	sharing_plug_type_id = g_type_register_static (SWITCHBOARD_TYPE_PLUG, "SharingPlug", &g_define_type_info, 0);
	SharingPlug_private_offset = g_type_add_instance_private (sharing_plug_type_id, sizeof (SharingPlugPrivate));
	return sharing_plug_type_id;
}

GType
sharing_plug_get_type (void)
{
	static volatile gsize sharing_plug_type_id__once = 0;
	if (g_once_init_enter (&sharing_plug_type_id__once)) {
		GType sharing_plug_type_id;
		sharing_plug_type_id = sharing_plug_get_type_once ();
		g_once_init_leave (&sharing_plug_type_id__once, sharing_plug_type_id);
	}
	return sharing_plug_type_id__once;
}

SwitchboardPlug*
get_plug (GModule* module)
{
	SharingPlug* plug = NULL;
	SharingPlug* _tmp0_;
	SwitchboardPlug* result;
#line 106 "../src/Plug.vala"
	g_return_val_if_fail (module != NULL, NULL);
#line 107 "../src/Plug.vala"
	g_debug ("Plug.vala:107: Activating Sharing plug");
#line 109 "../src/Plug.vala"
	_tmp0_ = sharing_plug_new ();
#line 109 "../src/Plug.vala"
	plug = _tmp0_;
#line 111 "../src/Plug.vala"
	result = (SwitchboardPlug*) plug;
#line 111 "../src/Plug.vala"
	return result;
#line 712 "Plug.c"
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

